<template lang="pug">
    div
        v-stepper(
            vertical
            non-linear
        )
            v-stepper-items
                v-card-title {{contextType}}
                v-stepper-step(
                    editable
                    step="1"
                ) Context Header
                v-stepper-content(
                    step="1"
                )
                    context-header(
                        :projectCode="currentProject.data.attributes.code"
                        :siteNumber="currentSite.data.attributes.number"
                        :trenchNumber="currentTrench.data.attributes.number"
                        :contextType="contextType"
                        :contextHeader="contextHeader"
                        @input="updateData"
                    )
                v-stepper-step(
                    editable
                    step="2"
                ) {{contextType}} Details
                v-stepper-content(
                    step="2"
                )
                    context-coffin(
                        v-if="contextType === 'Coffin'"
                        :coffin="localCoffin"
                        @input="updateData"
                        :options="options"
                    )
                    context-cut(
                        v-else-if="contextType === 'Cut'"
                        :cut="localCut"
                        @input="updateData"
                        :options="options"
                    )
                    context-deposit(
                        v-else-if="contextType === 'Deposit'"
                        :deposit="localDeposit"
                        @input="updateData"
                        :options="options"
                    )
                    context-masonry(
                        v-else-if="contextType === 'Masonry'"
                        :masonry="localMasonry"
                        @input="updateData"
                        :options="options"
                    )
                    context-skeleton(
                        v-else-if="contextType === 'Skeleton'"
                        :skeleton="localSkeleton"
                        @input="updateData"
                        :options="options"
                    )
                    context-timber(
                        v-else-if="contextType === 'Timber'"
                        :timber="localTimber"
                        @input="updateData"
                        :options="options"
                    )
                v-stepper-step(
                    editable
                    step="3"
                ) Matrix
                v-stepper-content(
                    step="3"
                )
                    context-matrix(
                        :contextNumber="contextHeader.contextNumber"
                        :aboveBelows="localAboveBelows"
                        @input="updateData"
                    )
                v-stepper-step(
                    editable
                    step="4"
                ) Drawing &amp; Samples
                v-stepper-content(
                    step="4"
                )
                    context-drawing-samples(
                        :plans="[]"
                        :sections="[]"
                        :samples="[]"
                        :photos="[]"
                        :sectionAllowed="true"
                        :sampleAllowed="contextType === 'Deposit' ? true : false"
                        @input=""
                    )
                v-stepper-step(
                    editable
                    step="5"
                ) Recorded By &amp; Checked By
                v-stepper-content(
                    step="5"
                )
                    context-recorded-checked(
                        :recordCheck="localRecordCheck"
                        :options="options"
                        @input="updateData"
                    )
                v-stepper-step(
                    editable
                    step="6"
                ) View and Submit
                v-stepper-content(
                    step="6"
                )
                    v-btn View Context
                    v-btn(
                        @click="saveContext"
                    ) Submit Context
        v-snackbar.text-center(
            v-model="snackbar"
            persistent
        ) {{ notification }}
</template>

<script>
import { mapGetters, mapActions } from "vuex";

export default {
    name: "Context",
    components: {
        contextHeader: () =>
            import("../components/ContextInput/Context_Header"),
        contextMatrix: () =>
            import("../components/ContextInput/Context_Matrix"),
        contextDrawingSamples: () =>
            import("../components/ContextInput/Context_Drawing_Samples"),
        contextRecordedChecked: () =>
            import("../components/ContextInput/Context_Recorded_Checked"),
        contextCoffin: () =>
            import("../components/ContextInput/Context_Coffin"),
        contextCut: () => import("../components/ContextInput/Context_Cut"),
        contextDeposit: () =>
            import("../components/ContextInput/Context_Deposit"),
        contextMasonry: () =>
            import("../components/ContextInput/Context_Masonry"),
        contextSkeleton: () =>
            import("../components/ContextInput/Context_Skeleton"),
        contextTimber: () => import("../components/ContextInput/Context_Timber")
    },
    data() {
        return {
            snackbar: false,
            notification: null,
            contextNumber: null,
            localCoffin: {
                description: null,
                discussion: null,
                preservation: null,
                finds_none: false,
                finds_breast_plate: false,
                finds_grip: false,
                finds_grip_plate: false,
                finds_hinge: false,
                finds_bracket: false,
                finds_fixing_nails: false,
                finds_shroud_pins: false,
                finds_fabric: false
            },
            localCut: {
                shape_in_plan: null,
                corners: null,
                dimentions_depth: null,
                break_of_slope_top: null,
                sides: null,
                break_of_slope_base: null,
                orientation: null,
                inclination_of_axis: null,
                truncation: null,
                comments: null,
                interpretation: null,
                interpretation_comment: null,
                disscussion: null
            },
            localDeposit: {
                compaction: null,
                colour: null,
                composition: null,
                inclusions: null,
                thickness: null,
                comments: null,
                weather: null,
                method: null,
                interpretation: null,
                interpretation_comment: null,
                disscussion: null,
                finds_none: false,
                finds_pot: false,
                finds_bone: false,
                finds_glass: false,
                finds_metal: false,
                finds_cbm: false,
                finds_other_bm: false,
                finds_wood: false,
                finds_leather: false
            },
            localMasonry: {
                materials: null,
                size_materials: null,
                finish: null,
                bond: null,
                form: null,
                direction: null,
                bonding_material: null,
                dimensions: null,
                worked_stones: null,
                other: null,
                interpretation: null,
                interpretation_comment: null
            },
            localSkeleton: {
                orientation: null,
                body: null,
                head: null,
                right_arm_hand: null,
                left_arm_hand: null,
                right_leg: null,
                left_leg: null,
                feet: null,
                degeneration_in_situ: null,
                degeneration_post_lift: null,
                comments: null,
                coffin: null,
                grave: null
            },
            localTimber: {
                timber_type: null,
                setting: null,
                orientation: null,
                cross_section: null,
                condition: null,
                dimensions_length: null,
                dimensions_width: null,
                dimensions_height: null,
                dimensions_units: null,
                convertsion: null,
                tool_markings: null,
                joint_fixings: null,
                surface_treatment: null,
                reuse: null,
                comments: null,
                interpretation: null,
                interpretation_comment: null,
                disscussion: null
            },
            localRecordCheck: {
                recorded_by: null,
                recorded_date: null,
                checked__by: null,
                checked_date: null
            },
            localAboveBelows: {
                aboves: [],
                belows: []
            },
            drawingsSamplesPhotos: {
                planNumbers: [],
                sectionNumbers: [],
                sampleNumbers: [],
                photoNumbers: []
            },
            contextHeader: {
                contextNumber: null,
                contextSameAs: []
            }
        };
    },
    mounted() {
        this.fetchOrientation({
            link: this.coffin.links.orientation
        });
        this.fetchDegreeOfContamination({
            link: this.coffin.links.degreeOfContamination
        });
        this.fetchInterpretation({
            link: this.coffin.links.interpretations
        });
        this.fetchMetalDetectorLocation({
            link: this.coffin.links.metalDetectorLocations
        });
        this.fetchSievingLocation({
            link: this.coffin.links.sievingLocations
        });
        this.fetchUnit({
            link: this.coffin.links.unit
        });
    },
    computed: {
        ...mapGetters({
            currentProject: "project/getAProject",
            currentSite: "site/getASite",
            currentTrench: "trench/getATrench",
            coffin: "coffin/getAllCoffin",
            doc: "degreeOfContamination/getDegreeOfContamination",
            interpretations: "interpretation/getInterpretation",
            mdl: "metalDetectorLocation/getMetalDetectorLocation",
            orientations: "orientation/getOrientation",
            sievingLocations: "sievingLocation/getSievingLocation",
            units: "unit/getUnit",
            getAllUser: "users/getAllUser"
        }),
        options() {
            let doc;
            if (this.doc.data) {
                doc = this.doc.data.map(element => {
                    return {
                        text: element.degree,
                        value: element.degree_of_contamination_id
                    };
                });
            }
            let interpretations;
            if (this.interpretations.data) {
                interpretations = this.interpretations.data.map(element => {
                    return {
                        text: element.interpretation,
                        value: element.interpretation_id
                    };
                });
            }
            let mdl;
            if (this.mdl.data) {
                mdl = this.mdl.data.map(element => {
                    return { text: element.location, value: element.m_d_l_id };
                });
            }
            let orientations;
            if (this.orientations.data) {
                orientations = this.orientations.data.map(element => {
                    return {
                        text: element.orientation_direction,
                        value: element.orientation_id
                    };
                });
            }
            // eslint-disable-next-line camelcase
            let sieving_locations;
            if (this.sievingLocations.data) {
                // eslint-disable-next-line camelcase
                sieving_locations = this.sievingLocations.data.map(element => {
                    return { text: element.location, value: element.s_l_id };
                });
            }
            let units;
            if (this.units.data) {
                units = this.units.data.map(element => {
                    return { text: element.unit, value: element.length_id };
                });
            }
            let users = this.getAllUser.data.map(element => {
                return {
                    text: element.attributes.email_address,
                    value: element.id
                };
            });
            return {
                degree_of_contamination: doc,
                interpretations: interpretations,
                metal_detecting_locations: mdl,
                orientations: orientations,
                sieving_locations: sieving_locations,
                units: units,
                users: users
            };
        },
        contextType() {
            return (
                this.$route.params.contextType.charAt(0).toUpperCase() +
                this.$route.params.contextType.slice(1)
            );
        },
        contextTypeNumber() {
            if (this.contextType === "Coffin") {
                return 1;
            } else if (this.contextType === "Cut") {
                return 2;
            } else if (this.contextType === "Deposit") {
                return 3;
            } else if (this.contextType === "Masonry") {
                return 4;
            } else if (this.contextType === "Skeleton") {
                return 5;
            } else if (this.contextType === "Timber") {
                return 6;
            } else {
                return 0;
            }
        }
    },
    methods: {
        ...mapActions({
            fetchOrientation: "orientation/fetchOrientation",
            fetchDegreeOfContamination:
                "degreeOfContamination/fetchDegreeOfContamination",
            fetchInterpretation: "interpretation/fetchInterpretation",
            fetchMetalDetectorLocation:
                "metalDetectorLocation/fetchMetalDetectorLocation",
            fetchSievingLocation: "sievingLocation/fetchSievingLocation",
            fetchUnit: "unit/fetchUnit",
            createACoffin: "coffin/createACoffin",
            createACut: "cut/createACut",
            createADeposit: "deposit/createADeposit",
            createAMasonry: "masonry/createAMasonry",
            createASkeleton: "skeleton/createASkeleton",
            createATimber: "timber/createATimber"
        }),
        updateData(event) {
            this["local" + event.context] = event.data;
        },
        saveContext() {
            const postData = {
                context: {
                    trench: this.currentTrench.data.id,
                    site: this.currentSite.data.id,
                    project: this.currentProject.data.id,
                    context_type: this.contextTypeNumber,
                    number: +this.contextHeader.contextNumber,
                    feature: null,
                    recorded_by: +this.localRecordCheck.recorded_by,
                    recorded_date: this.localRecordCheck.recorded_date,
                    checked_by: +this.localRecordCheck.checked_by,
                    checked_date: this.localRecordCheck.checked_date
                },
                above_belows: this.localAboveBelows,
                context_details: this[`local${this.contextType}`],
                drawing_context: {
                    drawing: this.drawingsSamplesPhotos.planNumbers.concat(
                        this.drawingsSamplesPhotos.sectionNumbers
                    )
                },
                photo_context: {
                    photo: this.drawingsSamplesPhotos.photoNumbers
                },
                same_as: this.contextHeader.contextSameAs
            };
            let creating;
            if (this.contextType === "Coffin") {
                creating = this.createACoffin({
                    link: this.currentTrench.data.relationships.coffin,
                    payload: postData
                });
            } else if (this.contextType === "Cut") {
                creating = this.createACut({
                    link: this.currentTrench.data.relationships.cut,
                    payload: postData
                });
            } else if (this.contextType === "Deposit") {
                creating = this.createADeposit({
                    link: this.currentTrench.data.relationships.deposit,
                    payload: postData
                });
            } else if (this.contextType === "Masonry") {
                creating = this.createAMasonry({
                    link: this.currentTrench.data.relationships.masonr,
                    payload: postData
                });
            } else if (this.contextType === "Skeleton") {
                creating = this.createASkeleton({
                    link: this.currentTrench.data.relationships.skeleton,
                    payload: postData
                });
            } else if (this.contextType === "Timber") {
                creating = this.createATimber({
                    link: this.currentTrench.data.relationships.timber,
                    payload: postData
                });
            }
            creating.then(response => {
                this.$router.push({
                    name: "trench-options",
                    params: {
                        projectid: this.$route.params.projectid,
                        siteid: this.$route.params.siteid,
                        trenchid: this.$route.params.trenchid
                    }
                });
            });
        }
    }
};
</script>
